/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiplusFontCollection.h
*
* Abstract:
*
*   Font collections (Installed and Private)
*
\**************************************************************************/

#ifndef _GDIPLUSFONTCOLL_H
#define _GDIPLUSFONTCOLL_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_InstalledFontCollection
{
    GP_GPFONTCOLLECTION *nativeFontCollection;
    GpStatus lastResult;
}GP_INSTALLEDFONTCOLLECTION;

// FontCollection
GpStatus _stdcall GdipNewInstalledFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipNewPrivateFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipDeletePrivateFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipGetFontCollectionFamilyCount(GP_GPFONTCOLLECTION* fontCollection, INT * numFound);
GpStatus _stdcall GdipGetFontCollectionFamilyList(GP_GPFONTCOLLECTION* fontCollection, INT numSought, GP_GPFONTFAMILY* gpfamilies[], INT* numFound);
GpStatus _stdcall GdipPrivateAddFontFile(GP_GPFONTCOLLECTION* fontCollection, const WCHAR* filename);
GpStatus _stdcall GdipPrivateAddMemoryFont(GP_GPFONTCOLLECTION* fontCollection, const void* memory, INT length);

GP_FONTCOLLECTION GpFontCollection(VOID);
VOID GpFontCollection_Delete(GP_FONTCOLLECTION * this);
INT GpFontCollection_GetFamilyCount(GP_FONTCOLLECTION * this);
GpStatus GpFontCollection_GetFamilies(GP_FONTCOLLECTION * this, INT numSought, GP_FONTFAMILY * gpfamilies, INT * numFound);
GpStatus GpFontCollection_GetLastStatus (GP_FONTCOLLECTION * this);
GpStatus GpFontCollection_SetStatus(GP_FONTCOLLECTION * this, GpStatus status);
GP_INSTALLEDFONTCOLLECTION GpInstalledFontCollection_InstalledFontCollection(VOID);
VOID GpInstalledFontCollection_Delete(GP_INSTALLEDFONTCOLLECTION * this);
GP_PRIVATEFONTCOLLECTION GpPrivateFontCollection_PrivateFontCollection(VOID);
VOID GpPrivateFontCollection_PrivateFontCollection_Dtor(GP_PRIVATEFONTCOLLECTION * this);
GpStatus GpPrivateFontCollection_AddFontFile(GP_PRIVATEFONTCOLLECTION * this, WCHAR* filename);
GpStatus GpPrivateFontCollection_AddMemoryFont(GP_PRIVATEFONTCOLLECTION * this, VOID * memory,INT length);

#endif // _GDIPLUSFONTCOLL_H
