/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiplusGraphics.h
*
* Abstract:
*
*   Graphics related declarations
*
\**************************************************************************/

#ifndef _GDIPLUSGRAPHICS_H
#define _GDIPLUSGRAPHICS_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_Graphics{
	GP_GPGRAPHICS * nativeGraphics;
	GpStatus lastResult;
}GP_GRAPHICS;

//---------------------------------------------------------
// Garphics Methods API calls
//---------------------------------------------------------
GpStatus _stdcall GdipCreateFromHDC(HDC hdc, GP_GPGRAPHICS **graphics);
GpStatus _stdcall GdipCreateFromHDC2(HDC hdc, HANDLE hDevice, GP_GPGRAPHICS **graphics);
GpStatus _stdcall GdipGetDC(GP_GPGRAPHICS * graphics, HDC * hdc);
GpStatus _stdcall GdipReleaseDC(GP_GPGRAPHICS * graphics, HDC hdc);
GpStatus _stdcall GdipDeleteGraphics(GP_GPGRAPHICS * graphics);
GpStatus _stdcall GdipCreateFromHWND(HWND hwnd, GP_GPGRAPHICS **graphics);
GpStatus _stdcall GdipCreateFromHWNDICM(HWND hwnd, GP_GPGRAPHICS **graphics);
GpStatus _stdcall GdipGetImageGraphicsContext(GP_GPIMAGE *image, GP_GPGRAPHICS **graphics);
GpStatus _stdcall GdipFlush(GP_GPGRAPHICS *graphics, GpFlushIntention intention);
GpStatus _stdcall GdipSetCompositingMode(GP_GPGRAPHICS *graphics, GpCompositingMode compositingMode);
GpStatus _stdcall GdipGetGpCompositingMode(GP_GPGRAPHICS *graphics, GpCompositingMode *compositingMode);
GpStatus _stdcall GdipSetRenderingOrigin(GP_GPGRAPHICS *graphics, INT x, INT y);
GpStatus _stdcall GdipGetRenderingOrigin(GP_GPGRAPHICS *graphics, INT *x, INT *y);
GpStatus _stdcall GdipSetGpCompositingQuality(GP_GPGRAPHICS *graphics, GpCompositingQuality compositingQuality);
GpStatus _stdcall GdipGetGpCompositingQuality(GP_GPGRAPHICS *graphics, GpCompositingQuality *compositingQuality);
GpStatus _stdcall GdipSetSmoothingMode(GP_GPGRAPHICS *graphics, GpSmoothingMode smoothingMode);
GpStatus _stdcall GdipGetSmoothingMode(GP_GPGRAPHICS *graphics, GpSmoothingMode *smoothingMode);
GpStatus _stdcall GdipSetPixelOffsetMode(GP_GPGRAPHICS* graphics, GpPixelOffsetMode pixelOffsetMode);
GpStatus _stdcall GdipGetPixelOffsetMode(GP_GPGRAPHICS *graphics, GpPixelOffsetMode *pixelOffsetMode);
GpStatus _stdcall GdipSetTextRenderingHint(GP_GPGRAPHICS *graphics, GpTextRenderingHint mode);
GpStatus _stdcall GdipGetTextRenderingHint(GP_GPGRAPHICS *graphics, GpTextRenderingHint *mode);
GpStatus _stdcall GdipGetCompositingMode(GP_GPGRAPHICS *graphics, GpCompositingMode *compositingMode);
GpStatus _stdcall GdipSetCompositingQuality(GP_GPGRAPHICS *graphics, GpCompositingQuality compositingQuality);
GpStatus _stdcall GdipGetCompositingQuality(GP_GPGRAPHICS *graphics, GpCompositingQuality *compositingQuality);
GpStatus _stdcall GdipSetTextContrast(GP_GPGRAPHICS *graphics, UINT contrast);
GpStatus _stdcall GdipSetTextGammaValue(GP_GPGRAPHICS *graphics, UINT gammaValue);
GpStatus _stdcall GdipGetTextContrast(GP_GPGRAPHICS *graphics, UINT * contrast);
GpStatus _stdcall GdipSetInterpolationMode(GP_GPGRAPHICS *graphics, GpInterpolationMode interpolationMode);
GpStatus _stdcall GdipGetInterpolationMode(GP_GPGRAPHICS *graphics, GpInterpolationMode *interpolationMode);
GpStatus _stdcall GdipSetWorldTransform(GP_GPGRAPHICS *graphics, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipResetWorldTransform(GP_GPGRAPHICS *graphics);
GpStatus _stdcall GdipMultiplyWorldTransform(GP_GPGRAPHICS *graphics, const GP_GPMATRIX *matrix, GpMatrixOrder order);
GpStatus _stdcall GdipTranslateWorldTransform(GP_GPGRAPHICS *graphics, REAL dx, REAL dy, GpMatrixOrder order);
GpStatus _stdcall GdipScaleWorldTransform(GP_GPGRAPHICS *graphics, REAL sx, REAL sy, GpMatrixOrder order);
GpStatus _stdcall GdipRotateWorldTransform(GP_GPGRAPHICS *graphics, REAL angle, GpMatrixOrder order);
GpStatus _stdcall GdipGetWorldTransform(GP_GPGRAPHICS *graphics, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipResetPageTransform(GP_GPGRAPHICS *graphics);
GpStatus _stdcall GdipGetPageUnit(GP_GPGRAPHICS *graphics, GpUnit *unit);
GpStatus _stdcall GdipGetPageScale(GP_GPGRAPHICS *graphics, REAL *scale);
GpStatus _stdcall GdipSetPageUnit(GP_GPGRAPHICS *graphics, GpUnit unit);
GpStatus _stdcall GdipSetPageScale(GP_GPGRAPHICS *graphics, REAL scale);
GpStatus _stdcall GdipGetDpiX(GP_GPGRAPHICS *graphics, REAL* dpi);
GpStatus _stdcall GdipGetDpiY(GP_GPGRAPHICS *graphics, REAL* dpi);
GpStatus _stdcall GdipTransformPoints(GP_GPGRAPHICS *graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GPPOINTF *points, INT count);
GpStatus _stdcall GdipTransformPointsI(GP_GPGRAPHICS *graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GPPOINTI *points, INT count);
GpStatus _stdcall GdipGetNearestColor(GP_GPGRAPHICS *graphics, ARGB* argb);
// Create the Win9x Halftone Palette (even on NT) with correct Desktop colors
HPALETTE _stdcall GdipCreateHalftonePalette();
GpStatus _stdcall GdipDrawLine(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x1, REAL y1, REAL x2, REAL y2);
GpStatus _stdcall GdipDrawLineI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x1, INT y1, INT x2, INT y2);
GpStatus _stdcall GdipDrawLines(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipDrawLinesI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipDrawArc(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipDrawArcI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipDrawBezier(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
GpStatus _stdcall GdipDrawBezierI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
GpStatus _stdcall GdipDrawBeziers(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipDrawBeziersI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipDrawRectangle(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipDrawRectangleI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipDrawRectangles(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPRECTF *rects, INT count);
GpStatus _stdcall GdipDrawRectanglesI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPRECTI *rects, INT count);
GpStatus _stdcall GdipDrawEllipse(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipDrawEllipseI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipDrawPie(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipDrawPieI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipDrawPolygon(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipDrawPolygonI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipDrawPath(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, GP_GPGRAPHICSPATH *path);
GpStatus _stdcall GdipDrawCurve(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipDrawCurveI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipDrawCurve2(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count, REAL tension);
GpStatus _stdcall GdipDrawCurve2I(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count, REAL tension);
GpStatus _stdcall GdipDrawCurve3(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus _stdcall GdipDrawCurve3I(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus _stdcall GdipDrawClosedCurve(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipDrawClosedCurveI(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipDrawClosedCurve2(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTF *points, INT count, REAL tension);
GpStatus _stdcall GdipDrawClosedCurve2I(GP_GPGRAPHICS *graphics, GP_GPPEN *pen, const GPPOINTI *points, INT count, REAL tension);
GpStatus _stdcall GdipGraphicsClear(GP_GPGRAPHICS *graphics, ARGB color);
GpStatus _stdcall GdipFillRectangle(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipFillRectangleI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipFillRectangles(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPRECTF *rects, INT count);
GpStatus _stdcall GdipFillRectanglesI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPRECTI *rects, INT count);
GpStatus _stdcall GdipFillPolygon(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush,  const GPPOINTF *points, INT count, GpFillMode fillMode);
GpStatus _stdcall GdipFillPolygonI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTI *points, INT count, GpFillMode fillMode);
GpStatus _stdcall GdipFillPolygon2(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipFillPolygon2I(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipFillEllipse(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipFillEllipseI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipFillPie(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipFillPieI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipFillPath(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, GP_GPGRAPHICSPATH *path);
GpStatus _stdcall GdipFillClosedCurve(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipFillClosedCurveI(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipFillClosedCurve2(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTF *points, INT count, REAL tension, GpFillMode fillMode);
GpStatus _stdcall GdipFillClosedCurve2I(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, const GPPOINTI *points, INT count, REAL tension, GpFillMode fillMode);
GpStatus _stdcall GdipFillRegion(GP_GPGRAPHICS *graphics, GP_GPBRUSH *brush, GP_GPREGION *region);
GpStatus _stdcall GdipDrawImage(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, REAL x, REAL y);
GpStatus _stdcall GdipDrawImageI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, INT x, INT y);
GpStatus _stdcall GdipDrawImageRect(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipDrawImageRectI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipDrawImagePoints(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, const GPPOINTF *dstpoints, INT count);
GpStatus _stdcall GdipDrawImagePointsI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, const GPPOINTI *dstpoints, INT count);
GpStatus _stdcall GdipDrawImagePointRect(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, REAL x, REAL y, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit);
GpStatus _stdcall GdipDrawImagePointRectI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, INT x, INT y, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit);

GpStatus _stdcall GdipDrawImageRectRect(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, REAL dstx,
                      REAL dsty, REAL dstwidth, REAL dstheight,
                      REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight,
                      GpUnit srcUnit, const GP_GPIMAGEATTRIBUTES* imageAttributes,
                      DrawImageAbort callback, VOID * callbackData);

GpStatus _stdcall GdipDrawImagePointsRect(GP_GPGRAPHICS *graphics,
						GP_GPIMAGE *image,
                        const GPPOINTF *points, INT count, REAL srcx,
                        REAL srcy, REAL srcwidth, REAL srcheight,
                        GpUnit srcUnit,
                        const GP_GPIMAGEATTRIBUTES* imageAttributes,
                        DrawImageAbort callback, VOID * callbackData);

GpStatus _stdcall GdipDrawImageRectRectI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image, INT dstx,
                       INT dsty, INT dstwidth, INT dstheight,
                       INT srcx, INT srcy, INT srcwidth, INT srcheight,
                       GpUnit srcUnit,
                       const GP_GPIMAGEATTRIBUTES* imageAttributes,
                       DrawImageAbort callback, VOID * callbackData);

GpStatus _stdcall GdipDrawImagePointsRectI(GP_GPGRAPHICS *graphics, GP_GPIMAGE *image,
                         const GPPOINTI *points, INT count, INT srcx,
                         INT srcy, INT srcwidth, INT srcheight,
                         GpUnit srcUnit,
                         const GP_GPIMAGEATTRIBUTES* imageAttributes,
                         DrawImageAbort callback, VOID * callbackData);

GpStatus _stdcall GdipSetClipGraphics(GP_GPGRAPHICS *graphics, GP_GPGRAPHICS *srcgraphics, GpCombineMode combineMode);
GpStatus _stdcall GdipSetClipRect(GP_GPGRAPHICS *graphics, REAL x, REAL y, REAL width, REAL height, GpCombineMode combineMode);
GpStatus _stdcall GdipSetClipRectI(GP_GPGRAPHICS *graphics, INT x, INT y, INT width, INT height, GpCombineMode combineMode);
GpStatus _stdcall GdipSetClipPath(GP_GPGRAPHICS *graphics, GP_GPGRAPHICSPATH *path, GpCombineMode combineMode);
GpStatus _stdcall GdipSetClipRegion(GP_GPGRAPHICS *graphics, GP_GPREGION *region, GpCombineMode combineMode);
GpStatus _stdcall GdipSetClipHrgn(GP_GPGRAPHICS *graphics, HRGN hRgn, GpCombineMode combineMode);
GpStatus _stdcall GdipResetClip(GP_GPGRAPHICS *graphics);
GpStatus _stdcall GdipTranslateClip(GP_GPGRAPHICS *graphics, REAL dx, REAL dy);
GpStatus _stdcall GdipTranslateClipI(GP_GPGRAPHICS *graphics, INT dx, INT dy);
GpStatus _stdcall GdipGetClip(GP_GPGRAPHICS *graphics, GP_GPREGION *region);
GpStatus _stdcall GdipGetClipBounds(GP_GPGRAPHICS *graphics, GPRECTF *rect);
GpStatus _stdcall GdipGetClipBoundsI(GP_GPGRAPHICS *graphics, GPRECTI *rect);
GpStatus _stdcall GdipIsClipEmpty(GP_GPGRAPHICS *graphics, BOOL *result);
GpStatus _stdcall GdipGetVisibleClipBounds(GP_GPGRAPHICS *graphics, GPRECTF *rect);
GpStatus _stdcall GdipGetVisibleClipBoundsI(GP_GPGRAPHICS *graphics, GPRECTI *rect);
GpStatus _stdcall GdipIsVisibleClipEmpty(GP_GPGRAPHICS *graphics, BOOL *result);
GpStatus _stdcall GdipIsVisiblePoint(GP_GPGRAPHICS *graphics, REAL x, REAL y, BOOL *result);
GpStatus _stdcall GdipIsVisiblePointI(GP_GPGRAPHICS *graphics, INT x, INT y, BOOL *result);
GpStatus _stdcall GdipIsVisibleRect(GP_GPGRAPHICS *graphics, REAL x, REAL y, REAL width, REAL height, BOOL *result);
GpStatus _stdcall GdipIsVisibleRectI(GP_GPGRAPHICS *graphics, INT x, INT y, INT width, INT height, BOOL *result);
GpStatus _stdcall GdipSaveGraphics(GP_GPGRAPHICS *graphics, GpGraphicsState *state);
GpStatus _stdcall GdipRestoreGraphics(GP_GPGRAPHICS *graphics, GpGraphicsState state);
GpStatus _stdcall GdipBeginContainer(GP_GPGRAPHICS *graphics, const GPRECTF* dstrect,
                   const GPRECTF *srcrect, GpUnit unit, GpGraphicsContainer *state);
GpStatus _stdcall GdipBeginContainerI(GP_GPGRAPHICS *graphics, const GPRECTI* dstrect,
                    const GPRECTI *srcrect, GpUnit unit, GpGraphicsContainer *state);
GpStatus _stdcall GdipBeginContainer2(GP_GPGRAPHICS *graphics, GpGraphicsContainer* state);
GpStatus _stdcall GdipEndContainer(GP_GPGRAPHICS *graphics, GpGraphicsContainer state);
GpStatus _stdcall GdipComment(GP_GPGRAPHICS* graphics, UINT sizeData, const BYTE * data);
GpStatus _stdcall GdipGetPathWorldBounds(GP_GPGRAPHICSPATH* path, GPRECTF* bounds, const GP_GPMATRIX *matrix, const GP_GPPEN *pen);
GpStatus _stdcall GdipGetPathWorldBoundsI(GP_GPGRAPHICSPATH* path, GPRECTI* bounds, const GP_GPMATRIX *matrix, const GP_GPPEN *pen);
GpStatus _stdcall GdipIsVisiblePathPoint(GP_GPGRAPHICSPATH* path, REAL x, REAL y, GP_GPGRAPHICS *graphics, BOOL *result);
GpStatus _stdcall GdipIsVisiblePathPointI(GP_GPGRAPHICSPATH* path, INT x, INT y, GP_GPGRAPHICS *graphics, BOOL *result);
GpStatus _stdcall GdipIsOutlineVisiblePathPoint(GP_GPGRAPHICSPATH* path, REAL x, REAL y, GP_GPPEN *pen, GP_GPGRAPHICS *graphics, BOOL *result);
GpStatus _stdcall GdipIsOutlineVisiblePathPointI(GP_GPGRAPHICSPATH* path, INT x, INT y, GP_GPPEN *pen, GP_GPGRAPHICS *graphics, BOOL *result);

//---------------------------------------------------------
// GdiPlusLib.lib functions
//---------------------------------------------------------
GP_GRAPHICS GpGraphics_FromHDC(HDC hdc);
GP_GRAPHICS GpGraphics_FromDEV(HDC hdc, HANDLE hdevice);
GP_GRAPHICS GpGraphics_FromHWND(HWND hwnd, BOOL icm);
GP_GRAPHICS GpGraphics_FromIMG(GP_IMAGE * image);
GpStatus 	GpGraphics_DrawLineF(GP_GRAPHICS * this, GP_PEN * pen, REAL x1, REAL y1, REAL x2, REAL y2);
GpStatus 	GpGraphics_DrawLinePtF(GP_GRAPHICS * this, GP_PEN * pen, const POINTF * pt1, const POINTF * pt2);
VOID 		GpGraphics_Delete(GP_GRAPHICS * this);
VOID 		GpGraphics_Flush(GP_GRAPHICS * this, GpFlushIntention intention);
HDC 		GpGraphics_GetHDC(GP_GRAPHICS * this);
VOID 		GpGraphics_ReleaseHDC(GP_GRAPHICS * this, HDC hdc);
GpStatus 	GpGraphics_SetRenderingOrigin(GP_GRAPHICS * this, INT x, INT y);
GpStatus 	GpGraphics_GetRenderingOrigin(GP_GRAPHICS * this, INT *x, INT *y);
GpStatus 	GpGraphics_SetCompositingMode(GP_GRAPHICS * this, GpCompositingMode compositingMode);
GpCompositingMode GpGraphics_GetCompositingMode(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetCompositingQuality(GP_GRAPHICS * this, GpCompositingQuality compositingQuality);
GpCompositingQuality GpGraphics_GetCompositingQuality(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetTextRenderingHint(GP_GRAPHICS * this, GpTextRenderingHint newMode);
GpTextRenderingHint GpGraphics_GetTextRenderingHint(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetTextContrast(GP_GRAPHICS * this, UINT contrast);
UINT GpGraphics_GetTextContrast(GP_GRAPHICS * this);
GpInterpolationMode GpGraphics_GetInterpolationMode(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetInterpolationMode(GP_GRAPHICS * this, GpInterpolationMode interpolationMode);
GpSmoothingMode GpGraphics_GetSmoothingMode(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetSmoothingMode(GP_GRAPHICS * this, GpSmoothingMode smoothingMode);
GpPixelOffsetMode GpGraphics_GetPixelOffsetMode(GP_GRAPHICS * this);
GpStatus 	GpGraphics_SetPixelOffsetMode(GP_GRAPHICS * this, GpPixelOffsetMode pixelOffsetMode);
GpStatus 	GpGraphics_SetTransform(GP_GRAPHICS * this, const GP_MATRIX * matrix);
GpStatus 	GpGraphics_ResetTransform(GP_GRAPHICS * this);
GpStatus 	GpGraphics_MultiplyTransform(GP_GRAPHICS * this, const GP_MATRIX * matrix, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpGraphics_TranslateTransform(GP_GRAPHICS * this, REAL dx,REAL dy, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpGraphics_ScaleTransform(GP_GRAPHICS * this, REAL sx,REAL sy, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpGraphics_RotateTransform(GP_GRAPHICS * this, REAL angle, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpGraphics_GetTransform(GP_GRAPHICS * this, GP_MATRIX * matrix);
GpStatus 	GpGraphics_SetPageUnit(GP_GRAPHICS * this, GpUnit unit);
GpStatus 	GpGraphics_SetPageScale(GP_GRAPHICS * this, REAL scale);
GpUnit 		GpGraphics_GetPageUnit(GP_GRAPHICS * this);
REAL 		GpGraphics_GetPageScale(GP_GRAPHICS * this);
REAL 		GpGraphics_GetDpiX(GP_GRAPHICS * this);
REAL 		GpGraphics_GetDpiY(GP_GRAPHICS * this);
GpStatus 	GpGraphics_TransformPointsF(GP_GRAPHICS * this, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, POINTF * pts, INT count);
GpStatus 	GpGraphics_TransformPointsI(GP_GRAPHICS * this, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, POINTI * pts,INT count);
GpStatus 	GpGraphics_GetNearestColor(GP_GRAPHICS * this, COLOR * color);
GpStatus 	GpGraphics_DrawLineI(GP_GRAPHICS * this, const GP_PEN* pen,INT x1,INT y1,INT x2,INT y2);
GpStatus 	GpGraphics_DrawLinePtI(GP_GRAPHICS * this, const GP_PEN* pen,const POINTI * pt1,const POINTI * pt2);
GpStatus 	GpGraphics_DrawLinesPtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count);
GpStatus 	GpGraphics_DrawLinesPtI(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count);
GpStatus 	GpGraphics_DrawArcF(GP_GRAPHICS * this, const GP_PEN* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawArcRcF(GP_GRAPHICS * this, const GP_PEN* pen, const RECTF * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawArcI(GP_GRAPHICS * this, const GP_PEN* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawArcRcI(GP_GRAPHICS * this, const GP_PEN* pen, const RECTI * rect,REAL startAngle,REAL sweepAngle);
GpStatus 	GpGraphics_DrawBezierF(GP_GRAPHICS * this, const GP_PEN* pen,REAL x1,REAL y1,REAL x2,REAL y2,REAL x3,REAL y3,REAL x4,REAL y4);
GpStatus 	GpGraphics_DrawBezierPtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * pt1, const POINTF * pt2, const POINTF * pt3, const POINTF * pt4);
GpStatus 	GpGraphics_DrawBeziersPtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count);
GpStatus 	GpGraphics_DrawBezierI(GP_GRAPHICS * this, const GP_PEN* pen, INT x1,INT y1,INT x2,INT y2,INT x3,INT y3,INT x4,INT y4);
GpStatus 	GpGraphics_DrawBezierPtI(GP_GRAPHICS * this, const GP_PEN* pen,const POINTI * pt1,const POINTI * pt2,const POINTI * pt3,const POINTI * pt4);
GpStatus 	GpGraphics_DrawBeziers(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count);
GpStatus 	GpGraphics_DrawRectangleRcF(GP_GRAPHICS * this, const GP_PEN* pen, const RECTF * rect);
GpStatus 	GpGraphics_DrawRectangleF(GP_GRAPHICS * this, const GP_PEN* pen, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphics_DrawRectangles(GP_GRAPHICS * this, const GP_PEN* pen,const RECTF * rects,INT count);
GpStatus 	GpGraphics_DrawRectangleRcI(GP_GRAPHICS * this, const GP_PEN* pen, const RECTI * rect);
GpStatus 	GpGraphics_DrawRectangleI(GP_GRAPHICS * this, const GP_PEN* pen, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphics_DrawRectanglesRcI(GP_GRAPHICS * this, const GP_PEN* pen,const RECTI * rects, INT count);
GpStatus 	GpGraphics_DrawEllipseRcF(GP_GRAPHICS * this, const GP_PEN* pen, const RECTF * rect);
GpStatus 	GpGraphics_DrawEllipseF(GP_GRAPHICS * this, const GP_PEN* pen, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphics_DrawEllipseRcI(GP_GRAPHICS * this, const GP_PEN* pen, const RECTI * rect);
GpStatus 	GpGraphics_DrawEllipseI(GP_GRAPHICS * this, const GP_PEN* pen, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphics_DrawPieRcF(GP_GRAPHICS * this, const GP_PEN* pen, const RECTF * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawPieF(GP_GRAPHICS * this, const GP_PEN* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawPieRcI(GP_GRAPHICS * this, const GP_PEN* pen, const RECTI * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawPieI(GP_GRAPHICS * this, const GP_PEN* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_DrawPolygonRcF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count);
GpStatus 	GpGraphics_DrawPolygonRcI(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count);
GpStatus 	GpGraphics_DrawPath(GP_GRAPHICS * this, const GP_PEN* pen, const GP_GRAPHICSPATH * path);
GpStatus 	GpGraphics_DrawCurvePtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count);
GpStatus 	GpGraphics_DrawCurve2PtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count, REAL tension);
GpStatus 	GpGraphics_DrawCurve3PtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count, INT offset, INT numberOfSegments, REAL tension = 0.5f);
GpStatus 	GpGraphics_DrawCurve2PtI(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count, REAL tension);
GpStatus 	GpGraphics_DrawCurve3PtI(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus 	GpGraphics_DrawClosedCurvePtF(GP_GRAPHICS * this, const GP_PEN* pen, const POINTF * points, INT count);
GpStatus 	GpGraphics_DrawClosedCurve2PtF(GP_GRAPHICS * this, const GP_PEN *pen, const POINTF * points, INT count, REAL tension);
GpStatus 	GpGraphics_DrawClosedCurvePtI(GP_GRAPHICS * this, const GP_PEN* pen, const POINTI * points, INT count);
GpStatus 	GpGraphics_DrawClosedCurve2PtI(GP_GRAPHICS * this, const GP_PEN *pen, const POINTI * points, INT count, REAL tension);
GpStatus 	GpGraphics_Clear(GP_GRAPHICS * this, const COLOR * color);
GpStatus 	GpGraphics_FillRectangleRcF(GP_GRAPHICS * this, const GP_BRUSH * brush, const RECTF * rect);
GpStatus 	GpGraphics_FillRectangleF(GP_GRAPHICS * this, const GP_BRUSH* brush, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphics_FillRectanglesRcF(GP_GRAPHICS * this, const GP_BRUSH* brush,const RECTF * rects,INT count);
GpStatus 	GpGraphics_FillRectangleRcI(GP_GRAPHICS * this, const GP_BRUSH* brush, const RECTI * rect);
GpStatus 	GpGraphics_FillRectangleI(GP_GRAPHICS * this, const GP_BRUSH* brush, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphics_FillRectanglesRcI(GP_GRAPHICS * this, const GP_BRUSH* brush,const RECTI * rects,INT count);
GpStatus 	GpGraphics_FillPolygonPtF(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTF * points, INT count);
GpStatus 	GpGraphics_FillPolygon1PtF(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTF * points, INT count, GpFillMode fillMode);
GpStatus 	GpGraphics_FillPolygonPtI(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTI * points, INT count);
GpStatus 	GpGraphics_FillPolygon1PtI(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTI * points, INT count, GpFillMode fillMode);
GpStatus 	GpGraphics_FillEllipseRcF(GP_GRAPHICS * this, const GP_BRUSH* brush, const RECTF * rect);
GpStatus 	GpGraphics_FillEllipseF(GP_GRAPHICS * this, const GP_BRUSH* brush, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphics_FillEllipseRcI(GP_GRAPHICS * this, const GP_BRUSH* brush, const RECTI * rect);
GpStatus 	GpGraphics_FillEllipseI(GP_GRAPHICS * this, const GP_BRUSH* brush, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphics_FillPieRcF(GP_GRAPHICS * this, const GP_BRUSH* brush, const RECTF * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_FillPieF(GP_GRAPHICS * this, const GP_BRUSH* brush, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_FillPieRcI(GP_GRAPHICS * this, const GP_BRUSH* brush, const RECTI * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_FillPieI(GP_GRAPHICS * this, const GP_BRUSH* brush, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphics_FillPath(GP_GRAPHICS * this, const GP_BRUSH * brush, const GP_GRAPHICSPATH * path);
GpStatus 	GpGraphics_FillClosedCurve(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTF * points, INT count);
GpStatus 	GpGraphics_FillClosedCurve2PtF(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTF * points, INT count, GpFillMode fillMode, REAL tension = 0.5f);
GpStatus 	GpGraphics_FillClosedCurve2PtI(GP_GRAPHICS * this, const GP_BRUSH* brush, const POINTI * points, INT count, GpFillMode fillMode, REAL tension = 0.5f);
GpStatus 	GpGraphics_FillRegion(GP_GRAPHICS * this, const GP_BRUSH* brush,const GP_REGION * region);
GpStatus 	GpGraphics_DrawStringRcF(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT * font, const RECTF * layoutRect, const GP_STRINGFORMAT * stringFormat, const GP_BRUSH * brush);
GpStatus 	GpGraphics_DrawStringPtF(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const POINTF * origin, const GP_BRUSH * brush);
GpStatus 	GpGraphics_DrawString(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const POINTF * origin,	const GP_STRINGFORMAT * stringFormat, const GP_BRUSH * brush);
GpStatus 	GpGraphics_MeasureString(GP_GRAPHICS * this, const WCHAR*string,INT length,const GP_FONT *font, const RECTF *layoutRect, const GP_STRINGFORMAT *stringFormat, RECTF *boundingBox, INT *codepointsFitted = 0, INT *linesFilled= 0);
GpStatus 	GpGraphics_MeasureString2(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const POINTF * origin,	const GP_STRINGFORMAT *stringFormat, RECTF *boundingBox);
GpStatus 	GpGraphics_MeasureString3(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const RECTF *layoutRect, RECTF *boundingBox);
GpStatus 	GpGraphics_MeasureString4(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const POINTF *origin, RECTF *boundingBox);
GpStatus 	GpGraphics_MeasureCharacterRanges(GP_GRAPHICS * this, const WCHAR * string, INT length, const GP_FONT *font, const RECTF *layoutRect, const GP_STRINGFORMAT *stringFormat, INT regionCount, GP_REGION * regions);
GpStatus 	GpGraphics_DrawDriverString(GP_GRAPHICS * this, const UINT16 * text, INT length, const GP_FONT * font, const GP_BRUSH * brush,	const POINTF * positions, INT flags, const GP_MATRIX * matrix);
GpStatus 	GpGraphics_MeasureDriverString(GP_GRAPHICS * this, const UINT16 * text, INT length, const GP_FONT * font, const POINTF * positions, INT flags, const GP_MATRIX * matrix, RECTF * boundingBox);
GpStatus 	GpGraphics_DrawCachedBitmap(GP_GRAPHICS * this, GP_CACHEDBITMAP * cb, INT x, INT y);
GpStatus 	GpGraphics_DrawImagePtF(GP_GRAPHICS * this, GP_IMAGE * image, const POINTF * point);
GpStatus 	GpGraphics_DrawImage2F(GP_GRAPHICS * this, GP_IMAGE * image, REAL x, REAL y);
GpStatus 	GpGraphics_DrawImageRcF(GP_GRAPHICS * this, GP_IMAGE * image, const RECTF * rect);
GpStatus 	GpGraphics_DrawImage4F(GP_GRAPHICS * this, GP_IMAGE * image, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphics_DrawImagePtI(GP_GRAPHICS * this, GP_IMAGE * image, const POINTI * point);
GpStatus 	GpGraphics_DrawImage2I(GP_GRAPHICS * this, GP_IMAGE * image, INT x, INT y);
GpStatus 	GpGraphics_DrawImageRcI(GP_GRAPHICS * this, GP_IMAGE * image, const RECTI * rect);
GpStatus 	GpGraphics_DrawImage4I(GP_GRAPHICS * this, GP_IMAGE * image, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphics_DrawImagePtsF(GP_GRAPHICS * this, GP_IMAGE * image, const POINTF * destPoints, INT count);
GpStatus 	GpGraphics_DrawImagePtsI(GP_GRAPHICS * this, GP_IMAGE * image, const POINTI * destPoints, INT count);
GpStatus 	GpGraphics_DrawImagePtRcF(GP_GRAPHICS * this, GP_IMAGE * image, REAL x, REAL y, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit);
GpStatus 	GpGraphics_DrawImageRcRcF(GP_GRAPHICS * this, GP_IMAGE * image, const RECTF * destRect, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, const GP_IMAGEATTRIBUTES* imageAttributes = NULL, DrawImageAbort callback = NULL, VOID* callbackData = NULL);
GpStatus 	GpGraphics_DrawImagePtsRcF(GP_GRAPHICS * this, GP_IMAGE * image, const POINTF * destPoints, INT count, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, const GP_IMAGEATTRIBUTES * imageAttributes = NULL, DrawImageAbort callback = NULL, VOID * callbackData = NULL);
GpStatus 	GpGraphics_DrawImagePtRcI(GP_GRAPHICS * this, GP_IMAGE * image, INT x, INT y, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit);
GpStatus 	GpGraphics_DrawImageRcRcI(GP_GRAPHICS * this, GP_IMAGE * image, const RECTI * destRect, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, const GP_IMAGEATTRIBUTES * imageAttributes, DrawImageAbort callback, VOID* callbackData);
GpStatus 	GpGraphics_DrawImagePtsRcI(GP_GRAPHICS * this, GP_IMAGE * image, const POINTI * destPoints, INT count, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, const GP_IMAGEATTRIBUTES * imageAttributes, DrawImageAbort callback, VOID* callbackData);
GpStatus 	GpGraphics_EnumerateMetafilePtF(GP_GRAPHICS * this, const GP_METAFILE * metafile,const POINTF *destPoint, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafilePtI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTI * destPoint, EnumerateMetafileProc callback,	VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcF(GP_GRAPHICS * this, const GP_METAFILE * metafile, const RECTF * destRect, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const RECTI * destRect, EnumerateMetafileProc callback, VOID *callbackData,	const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafilePtsF(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTF * destPoints, INT count,	EnumerateMetafileProc callback, VOID *callbackData,	const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafilePtsI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTI * destPoints, INT count, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcPtF(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTF *destPoint, const RECTF * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcPtI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTI * destPoint, const RECTI * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcRcF(GP_GRAPHICS * this, const GP_METAFILE *metafile, const RECTF * destRect, const RECTF * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcRcI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const RECTI * destRect, const RECTI * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcPtsF(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTF * destPoints, INT count, const RECTF * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_EnumerateMetafileRcPtsI(GP_GRAPHICS * this, const GP_METAFILE *metafile, const POINTI * destPoints,INT count,	const RECTI * srcRect, GpUnit srcUnit, EnumerateMetafileProc callback, VOID *callbackData, const GP_IMAGEATTRIBUTES * imageAttributes);
GpStatus 	GpGraphics_SetClip(GP_GRAPHICS * this, const GP_GRAPHICS * g, GpCombineMode combineMode);
GpStatus 	GpGraphics_SetClipRcF(GP_GRAPHICS * this, const RECTF * rect, GpCombineMode combineMode);
GpStatus 	GpGraphics_SetClipRcI(GP_GRAPHICS * this, const RECTI * rect, GpCombineMode combineMode);
GpStatus 	GpGraphics_SetClipPath(GP_GRAPHICS * this, const GP_GRAPHICSPATH * path, GpCombineMode combineMode);
GpStatus 	GpGraphics_SetClipRegion(GP_GRAPHICS * this, const GP_REGION* region, GpCombineMode combineMode);
GpStatus 	GpGraphics_SetClipHrgn(GP_GRAPHICS * this, HRGN hRgn, GpCombineMode combineMode);
GpStatus 	GpGraphics_IntersectClipRcF(GP_GRAPHICS * this, const RECTF * rect);
GpStatus 	GpGraphics_IntersectClipRc(GP_GRAPHICS * this, const RECTI * rect);
GpStatus 	GpGraphics_IntersectClipRegion(GP_GRAPHICS * this, const GP_REGION* region);
GpStatus 	GpGraphics_ExcludeClipRcF(GP_GRAPHICS * this, const RECTF * rect);
GpStatus 	GpGraphics_ExcludeClipRcI(GP_GRAPHICS * this, const RECTI * rect);
GpStatus 	GpGraphics_ExcludeClipRegion(GP_GRAPHICS * this, const GP_REGION* region);
GpStatus 	GpGraphics_ResetClip(GP_GRAPHICS * this);
GpStatus 	GpGraphics_TranslateClipF(GP_GRAPHICS * this, REAL dx, REAL dy);
GpStatus 	GpGraphics_TranslateClipI(GP_GRAPHICS * this, INT dx, INT dy);
GpStatus 	GpGraphics_GetClip(GP_GRAPHICS * this, GP_REGION* region);
GpStatus 	GpGraphics_GetClipBoundsF(GP_GRAPHICS * this, RECTF * rect);
GpStatus 	GpGraphics_GetClipBoundsI(GP_GRAPHICS * this, RECTI * rect);
BOOL 		GpGraphics_IsClipEmpty(GP_GRAPHICS * this);
GpStatus 	GpGraphics_GetVisibleClipBoundsF(GP_GRAPHICS * this, RECTF *rect);
GpStatus 	GpGraphics_GetVisibleClipBoundsI(GP_GRAPHICS * this, RECTI *rect);
BOOL 		GpGraphics_IsVisibleClipEmpty(GP_GRAPHICS * this, BOOL booln);
BOOL 		GpGraphics_IsVisibleI(GP_GRAPHICS * this, INT x, INT y);
BOOL 		GpGraphics_IsVisiblePtI(GP_GRAPHICS * this, const POINTI * point);
BOOL 		GpGraphics_IsVisible4I(GP_GRAPHICS * this, INT x, INT y, INT width, INT height);
BOOL 		GpGraphics_IsVisibleRcI(GP_GRAPHICS * this, const RECTI * rect);
BOOL 		GpGraphics_IsVisibleF(GP_GRAPHICS * this, REAL x, REAL y);
BOOL 		GpGraphics_IsVisiblePtF(GP_GRAPHICS * this, const POINTF * point);
BOOL 		GpGraphics_IsVisible4F(GP_GRAPHICS * this, REAL x, REAL y, REAL width, REAL height);
BOOL 		GpGraphics_IsVisibleRcF(GP_GRAPHICS * this, const RECTF * rect);
GpGraphicsState GpGraphics_Save(GP_GRAPHICS * this);
GpStatus 	GpGraphics_Restore(GP_GRAPHICS * this, GpGraphicsState gstate);
GpGraphicsContainer GpGraphics_BeginContainerF(GP_GRAPHICS * this, const RECTF * dstrect, const RECTF * srcrect, GpUnit unit);
GpGraphicsContainer GpGraphics_BeginContainerI(GP_GRAPHICS * this, const RECTI *dstrect,const RECTI * srcrect, GpUnit unit);
GpGraphicsContainer GpGraphics_BeginContainer(GP_GRAPHICS * this);
GpStatus 	GpGraphics_EndContainer(GP_GRAPHICS * this, GpGraphicsContainer state);
GpStatus 	GpGraphics_AddMetafileComment(GP_GRAPHICS * this, const BYTE * data, UINT sizeData);
HPALETTE 	GpGraphics_GetHalftonePalette(VOID);
GpStatus 	GpGraphics_PathGetBoundsRcF(GP_GRAPHICSPATH * this, RECTF * bounds, const GP_MATRIX * matrix, const GP_PEN * pen);
GpStatus 	GpGraphics_PathGetBoundsRcI(GP_GRAPHICSPATH * this, RECTI * bounds, const GP_MATRIX* matrix, const GP_PEN * pen);
BOOL 		GpGraphics_PathIsVisibleF(GP_GRAPHICSPATH * this, REAL x, REAL y, const GP_GRAPHICS * g);
BOOL 		GpGraphics_PathIsVisibleI(GP_GRAPHICSPATH * this, INT x,INT y, const GP_GRAPHICS * g);
BOOL 		GpGraphics_PathIsOutlineVisibleF(GP_GRAPHICSPATH * this, REAL x, REAL y, const GP_PEN * pen, const GP_GRAPHICS * g);
BOOL 		GpGraphics_PathIsOutlineVisibleI(GP_GRAPHICSPATH * this, INT x, INT y, const GP_PEN * pen, const GP_GRAPHICS * g);

#endif
