/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft GdiPlus C++ header files.
*
* Module Name:
*
*   GdiplusHeaders.h
*
* Abstract:
*
*   GDI+ Native C++ public header file
*
\**************************************************************************/

#ifndef _GDIPLUSHEADERS_H
#define _GDIPLUSHEADERS_H

//--------------------------------------------------------------------------
// Abstract base class for regions
//--------------------------------------------------------------------------

//  Include the class declarations here and have inline class implementation
//  in separate file to avoid circular references.

// class Region : public GplusBase { public: friend class Graphics;

// protected:

/*
GP_REGION overloaded Gp_Region(void);
GP_REGION overloaded Gp_Region(const GP_RECTF*);
GP_REGION overloaded Gp_Region(const GP_RECTI*);
GP_REGION overloaded Gp_Region(const GP_GRAPHICSPATH*);
GP_REGION overloaded Gp_Region(const BYTE*,INT);
GP_REGION overloaded Gp_Region(HRGN hRgn);
*/
//static
GP_REGION* _stdcall Gp_Region_FromHRGN(GP_REGION*,HRGN);

void _stdcall Gp_Region_Dtor(GP_REGION*);

// GP_REGION* // pointer issue
GP_REGION _stdcall Gp_Region_Clone(const GP_REGION*);

GpStatus _stdcall Gp_Region_MakeInfinite(GP_REGION*);
GpStatus _stdcall Gp_Region_MakeEmpty(GP_REGION*);

// Get the size of the buffer needed for the GetData method
UINT _stdcall Gp_Region_GetDataSize(const GP_REGION*);

// buffer     - where to put the data
// bufferSize - how big the buffer is (should be at least as big as GetDataSize())
// sizeFilled - if not NULL, this is an OUT param that says how many bytes
//              of data were written to the buffer.
/*
GpStatus _stdcall Region_GetData(const GP_REGION*, BYTE*,UINT, UINT* sizeFilled = NULL);
GpStatus overloaded Gp_Region_Intersect(GP_REGION*, const GP_RECTI*);
GpStatus overloaded Gp_Region_Intersect(GP_REGION*, const GP_RECTF*);
GpStatus overloaded Gp_Region_Intersect(GP_REGION*, const GP_GRAPHICSPATH*);
GpStatus overloaded Gp_Region_Intersect(GP_REGION*, const GP_REGION*);
GpStatus overloaded Gp_Region_Union(GP_REGION*, const GP_RECTI*);
GpStatus overloaded Gp_Region_Union(GP_REGION*, const GP_RECTF*);
GpStatus overloaded Gp_Region_Union(GP_REGION*, const GP_GRAPHICSPATH*);
GpStatus overloaded Gp_Region_Union(GP_REGION*, const GP_REGION*);
GpStatus overloaded Gp_Region_Xor(GP_REGION*, const GP_RECTI*);
GpStatus overloaded Gp_Region_Xor(GP_REGION*, const GP_RECTF*);
GpStatus overloaded Gp_Region_Xor(GP_REGION*, const GP_GRAPHICSPATH*);
GpStatus overloaded Gp_Region_Xor(GP_REGION*, const GP_REGION*);
GpStatus overloaded Gp_Region_Exclude(GP_REGION*, const GP_RECTI*);
GpStatus overloaded Gp_Region_Exclude(GP_REGION*, const GP_RECTF*);
GpStatus overloaded Gp_Region_Exclude(GP_REGION*, const GP_GRAPHICSPATH*);
GpStatus overloaded Gp_Region_Exclude(GP_REGION*, const GP_REGION*);
GpStatus overloaded Gp_Region_Complement(GP_REGION*, const GP_RECTI*);
GpStatus overloaded Gp_Region_Complement(GP_REGION*, const GP_RECTF*);
GpStatus overloaded Gp_Region_Complement(GP_REGION*, const GP_GRAPHICSPATH*);
GpStatus overloaded Gp_Region_Complement(GP_REGION*, const GP_REGION*);
GpStatus overloaded Gp_Region_Translate(GP_REGION*, REAL, REAL);
GpStatus overloaded Gp_Region_Translate(GP_REGION*, INT, INT);
GpStatus overloaded Gp_Region_Transform(GP_REGION*, const GP_MATRIX*);

GpStatus overloaded Gp_Region_GetBounds(const GP_REGION*, GP_RECTI*, const GP_GRAPHICS*);
GpStatus overloaded Gp_Region_GetBounds(const GP_REGION*, GP_RECTF*, const GP_GRAPHICS*);
HRGN   _stdcall Gp_Region_GetHRGN(const GP_REGION*, const GP_GRAPHICS *);
BOOL _stdcall Gp_Region_IsEmpty(const GP_REGION*, const GP_GRAPHICS *);
BOOL _stdcall Gp_Region_IsInfinite(const GP_REGION*, const GP_GRAPHICS *);

BOOL overloaded Gp_Region_IsVisible(const GP_REGION*, const GP_POINTI*, const GP_GRAPHICS* g = NULL);
BOOL overloaded Gp_Region_IsVisible(const GP_REGION*, const GP_POINTF*, const GP_GRAPHICS* g = NULL);
BOOL overloaded Gp_Region_IsVisible(const GP_REGION*, const GP_RECTI*, const GP_GRAPHICS* g = NULL);
BOOL overloaded Gp_Region_IsVisible(const GP_REGION*, const GP_RECTF*, const GP_GRAPHICS* g = NULL);

/*

BOOL overloaded Gp_Region_IsVisible(
	const GP_REGION* this,
	INT x,INT y,
	const GP_GRAPHICS* g = NULL
	)
{
    return Gp_Region_IsVisible(this, Point(x, y), g);
}

BOOL overloaded Gp_Region_IsVisible(
	const GP_REGION* this,
	REAL x, REAL y,
	const GP_GRAPHICS* g = NULL
	)
{
    return Gp_Region_IsVisible(this, PointF(x, y), g);
}

BOOL overloaded Gp_Region_IsVisible(
    const GP_REGION* this,
    INT x, INT y,
    INT width, INT height,
    const GP_GRAPHICS* g
	)
{
    return Gp_Region_IsVisible(this, Rect(x, y, width, height), g);
}


BOOL overloaded Gp_Region_IsVisible(
    const GP_REGION* this,
    REAL x, REAL y,
    REAL width, REAL height,
    const GP_GRAPHICS* g = NULL
	)
{
    return Gp_Region_IsVisible(this, RectF(x, y, width, height), g);
}

*/

BOOL _stdcall Gp_Region_Equals(const GP_REGION*, const GP_REGION*, const GP_GRAPHICS* g);
UINT _stdcall Gp_Region_GetRegionScansCount(const GP_REGION*, const GP_MATRIX*);

GpStatus overloaded Gp_Region_GetRegionScans(const GP_REGION*, const GP_MATRIX*, GP_RECTF*, INT*);
GpStatus overloaded Gp_Region_GetRegionScans(const GP_REGION*, const GP_MATRIX*, GP_RECTI*, INT*);

GpStatus _stdcall Gp_Region_GetLastStatus(const GP_REGION*);

GpStatus _stdcall
Gp_Region_SetStatus(
	GP_REGION* this,
	GpStatus status
	)
{
    if (status != Gp_Ok)
        return (this.lastResult = status);
    else
        return status;
}

GP_REGION _stdcall Gp_Region_Region(GP_GPREGION* nativeRegion);

VOID _stdcall Gp_Region_SetNativeRegion(GP_REGION *, GP_GPREGION* nativeRegion);


/*
protected:

#ifdef DCR_USE_NEW_250932

private:
    Region(const Region *region);
    Region* operator=(const Region *region);
protected:

#else
    Region(const Region *region)
    {
        region; // reference parameter
        SetStatus(NotImplemented);
    }

    Region* operator=(const Region *region)
    {
       region;  // reference parameter
       SetStatus(NotImplemented);
       return *this;
    }
#endif
*/




//--------------------------------------------------------------------------
// Abstract base class for FontFamily
//--------------------------------------------------------------------------

// class FontFamily : public GplusBase { public:
// friend class Font;
//    friend class Graphics;
//    friend class GraphicsPath;
//    friend class FontCollection;

typedef struct tagGp_FontFamily
{
    GP_GPFONTFAMILY    *nativeFamily;
    //mutable
    GpStatus   lastResult;
}
GP_FONTFAMILY;


//static
BYTE GpGenericSansSerifFontFamilyBuffer[sizeof(GP_FONTFAMILY)] = {0};
//static
BYTE GpGenericSerifFontFamilyBuffer    [sizeof(GP_FONTFAMILY)] = {0};
//static
BYTE GpenericMonospaceFontFamilyBuffer[sizeof(GP_FONTFAMILY)] = {0};


GP_FONTFAMILY overloaded Gp_FontFamily(void);

GP_FONTFAMILY overloaded Gp_FontFamily(const WCHAR *, const GP_FONTCOLLECTION *fontCollection = NULL);

void Gp_FontFamily_Dtor(GP_FONTFAMILY*);

// static const GP_FONTFAMILY * _stdcall Gp_FontFamily_GenericSansSerif(GP_FONTFAMILY*);
const GP_FONTFAMILY * _stdcall Gp_FontFamily_GenericSansSerif(void);

// static const GP_FONTFAMILY * _stdcall Gp_FontFamily_GenericSerif(GP_FONTFAMILY*);

const GP_FONTFAMILY * _stdcall Gp_FontFamily_GenericSerif(void);

// static const GP_FONTFAMILY * _stdcall Gp_FontFamily_GenericMonospace(GP_FONTFAMILY*);

const GP_FONTFAMILY * Gp_FontFamily_GenericMonospace(void);

Status _stdcall Gp_FontFamily_GetFamilyName(const GP_FONTFAMILY*, WCHAR name[LF_FACESIZE], LANGID language = 0);

//  Copy operator
// GP_FONTFAMILY * _stdcall Gp_FontFamily_Clone(const GP_FONTFAMILY*);
GP_FONTFAMILY _stdcall
Gp_FontFamily_Clone(
    const GP_FONTFAMILY* this
    );

BOOL _stdcall Gp_FontFamily_IsAvailable(const GP_FONTFAMILY* this)
{
    return (this.nativeFamily != NULL);
};

BOOL _stdcall Gp_FontFamily_IsStyleAvailable(const GP_FONTFAMILY*, INT);

UINT16  _stdcall Gp_FontFamily_GetEmHeight(const GP_FONTFAMILY*,INT);
UINT16  _stdcall Gp_FontFamily_GetCellAscent(const GP_FONTFAMILY*,INT);
UINT16  _stdcall Gp_FontFamily_GetCellDescent(const GP_FONTFAMILY*,INT);
UINT16  _stdcall Gp_FontFamily_GetLineSpacing(const GP_FONTFAMILY*,INT);

///////////////////////////////////////////////////////////

Status _stdcall Gp_FontFamily_GetLastStatus(GP_FONTFAMILY*); // const

/*
#ifdef DCR_USE_NEW_250932

private:
    FontFamily(const FontFamily *);
    FontFamily* operator=(const FontFamily *);

#endif

protected:
    GpStatus SetStatus(Status status) const;

    // private constructor for copy
    FontFamily(GpFontFamily * nativeFamily, GpStatus status);

///////////////////////////////////////
//  Data members
protected:
*/


//--------------------------------------------------------------------------
// Abstract base class for fonts
//--------------------------------------------------------------------------

// class Font : public GplusBase { public: friend class Graphics;

typedef struct tagGp_Font
{
    GP_GPFONT* nativeFont;
    // mutable
    GpStatus lastResult;
}
GP_FONT;


GP_FONT overloaded Gp_Font(HDC);
GP_FONT overloaded Gp_Font(HDC, const LOGFONTA*);
GP_FONT overloaded Gp_Font(HDC, const LOGFONTW*);

#ifdef DCR_USE_NEW_127084
GP_FONT overloaded Gp_Font(HDC hdc, const HFONT hfont);
#endif

GP_FONT overloaded Gp_Font(
    const GP_FONTFAMILY *,
    REAL,
    INT style /* = Gp_FontStyleRegular */,
    Unit unit = UnitPoint
);

/* redefinition of optional argument 1 in Gp_Font
GP_FONT overloaded Gp_Font(
    const WCHAR *           familyName,
    REAL            emSize,
    INT                     style,  // = Gp_FontStyleRegular
    Unit            unit,   // = UnitPoint
    const GP_FONTCOLLECTION*  fontCollection = NULL
);
*/

Status _stdcall Gp_Font_GetLogFontA(const GP_FONT*, const GP_GRAPHICS* g,LOGFONTA * logfontA);
Status _stdcall Gp_Font_GetLogFontW(const GP_FONT*, const GP_GRAPHICS* g,LOGFONTW * logfontW);

//GP_FONT* _stdcall Gp_Font_Clone(const GP_FONT*);
GP_FONT _stdcall Gp_Font_Clone(const GP_FONT*);

void _stdcall Gp_Font_Dtor(GP_FONT*);
BOOL _stdcall Gp_Font_IsAvailable(const GP_FONT*);
INT _stdcall Gp_Font_GetStyle(const GP_FONT*);
REAL _stdcall Gp_Font_GetSize(const GP_FONT*);
Unit _stdcall Gp_Font_GetUnit(const GP_FONT*);
Status _stdcall Gp_Font_GetLastStatus(const GP_FONT*);
REAL _stdcall Gp_Font_GetHeight(const GP_FONT*, const GP_GRAPHICS *graphics = NULL);

/*
#ifdef DCR_USE_NEW_125467
REAL        Gp_Font_GetHeight(const GP_FONT*, REAL dpi);
#endif
*/

Status _stdcall Gp_Font_GetFamily(const GP_FONT*, GP_FONTFAMILY *family);

/*
#ifdef DCR_USE_NEW_250932

private:
    Font(const Font *);
    Font* operator=(const Font *);

#endif

protected:
    Font(GpFont* font, GpStatus status);
    VOID SetNativeFont(GpFont *Font);
    GpStatus SetStatus(Status status) const;

protected:

     * handle to native line texture object

*/


//--------------------------------------------------------------------------
// Abstract base classes for font collections
//--------------------------------------------------------------------------

// class FontCollection : public GplusBase { public: friend class FontFamily;

typedef struct tagGp_FontCollection
{
    GP_GPFONTCOLLECTION *nativeFontCollection;
    // mutable
    GpStatus    lastResult;
}
GP_FONTCOLLECTION;

GP_FONTCOLLECTION /* overloaded */ Gp_FontCollection(void);
void /* virtual ~ */ Gp_FontCollection_Dtor(GP_FONTCOLLECTION *);

// number of enumerable families in the collection
INT _stdcall Gp_FontCollection_GetFamilyCount(GP_FONTCOLLECTION *); //const

// enumerate the fonts in a collection
Status _stdcall Gp_FontCollection_GetFamilies(
	const GP_FONTCOLLECTION*, INT, GP_FONTFAMILY*,INT*);

Status _stdcall Gp_FontCollection_GetLastStatus(const GP_FONTCOLLECTION*);

Status _stdcall Gp_FontCollection_SetStatus(GP_FONTCOLLECTION*,Status); //const

/*
#ifdef DCR_USE_NEW_250932

private:
    FontCollection(const FontCollection *);
    FontCollection* operator=(const FontCollection *);

#endif

protected:

*/


// ---------------------------------------------------------------------------

// class InstalledFontCollection : public FontCollection { public:

typedef struct tagGp_InstalledFontCollection
{
    GP_GPFONTCOLLECTION *nativeFontCollection;
    // mutable
    GpStatus    lastResult;
}
GP_INSTALLEDFONTCOLLECTION;


GP_INSTALLEDFONTCOLLECTION _stdcall Gp_InstalledFontCollection(void);
void Gp_InstalledFontCollection_Dtor(GP_INSTALLEDFONTCOLLECTION*);

Status Gp_InstalledFontCollection_SetStatus(
    const GP_INSTALLEDFONTCOLLECTION*,
    GpStatus status
);

/*
#ifdef DCR_USE_NEW_250932

private:
    InstalledFontCollection(const InstalledFontCollection *);
    InstalledFontCollection* operator=(const InstalledFontCollection *);

#endif

protected:
#ifndef DCR_USE_NEW_235072
    GpStatus InstallFontFile(IN const WCHAR* filename);
    GpStatus UninstallFontFile(IN const WCHAR* filename);
#endif

*/


// ---------------------------------------------------------------------------

// class PrivateFontCollection : public FontCollection { public:

typedef struct tagGp_PrivateFontCollection
{
    GP_GPFONTCOLLECTION *nativeFontCollection;
    // mutable
    GpStatus    lastResult;
}
GP_PRIVATEFONTCOLLECTION;

GP_PRIVATEFONTCOLLECTION _stdcall Gp_PrivateFontCollection(void);

Status _stdcall Gp_PrivateFontCollection_AddFontFile(
    GP_PRIVATEFONTCOLLECTION*, const WCHAR*
);
Status _stdcall Gp_PrivateFontCollection_AddMemoryFont(
    GP_PRIVATEFONTCOLLECTION*, const VOID*, INT
);

/*
#ifdef DCR_USE_NEW_250932

private:
    PrivateFontCollection(const PrivateFontCollection *);
    PrivateFontCollection* operator=(const PrivateFontCollection *);

#endif
};
*/


//--------------------------------------------------------------------------
// Abstract base class for bitmap image and metafile
//--------------------------------------------------------------------------

// !!! Note:
//  Include the class declarations here and have the inline class
//  implementation in a separate file.  This is done to resolve a
//  circular dependency since one of the Bitmap methods needs to
//  access the private member nativeGraphics of the Graphics object.

/*
class Image : public GplusBase
{
public:
    friend class Brush;
    friend class TextureBrush;
    friend class Graphics;
*/

typedef struct tagGp_Image
{
    GP_GPIMAGE* nativeImage;
    //mutable
    GpStatus lastResult;
    //mutable
    GpStatus loadStatus;
}
GP_IMAGE;


#ifndef DCR_USE_NEW_140782

GP_IMAGE overloaded Gp_Image(const WCHAR* filename);
GP_IMAGE overloaded Gp_Image(IStream* stream);
//static GP_IMAGE*
GP_IMAGE _stdcall
Gp_Image_FromFile(
	GP_IMAGE*,
	const WCHAR* filename
	);

// static GP_IMAGE* _stdcall
GP_IMAGE _stdcall
Gp_Image_FromStream(IStream* stream);

#else

GP_IMAGE overloaded Gp_Image(const WCHAR* filename, BOOL useEmbeddedColorManagement = FALSE);
GP_IMAGE overloaded Gp_Image(IStream* stream, BOOL useEmbeddedColorManagement = FALSE);

// static GP_IMAGE*
GP_IMAGE _stdcall
Gp_Image_FromFile(
	const WCHAR* filename,
	BOOL useEmbeddedColorManagement = FALSE
	);

//static GP_IMAGE* _stdcall
GP_IMAGE _stdcall
Gp_Image_FromStream(
	IStream* stream,
	BOOL useEmbeddedColorManagement = FALSE
	);

#endif

// virtual ~Image();
void Gp_Image_Dtor(GP_IMAGE*);

// virtual Image* Clone();
GP_IMAGE* _stdcall Gp_Image_Close(GP_IMAGE*);

Status overloaded Gp_Image_Save(
    GP_IMAGE*,
    const WCHAR* filename,
    const CLSID* clsidEncoder,
    const GP_ENCODERPARAMETERS *encoderParams = NULL
);
Status overloaded Gp_Image_Save(
    GP_IMAGE*,
    IStream* stream,
    const CLSID* clsidEncoder,
    const GP_ENCODERPARAMETERS *encoderParams = NULL
);
Status overloaded Gp_Image_SaveAdd(
    GP_IMAGE*,
    const GP_ENCODERPARAMETERS* encoderParams
);
Status overloaded Gp_Image_SaveAdd(
    GP_IMAGE*,
    GP_IMAGE* newImage,
    const GP_ENCODERPARAMETERS* encoderParams
);
ImageType _stdcall Gp_Image_GetType(const GP_IMAGE*);

Status _stdcall Gp_Image_GetPhysicalDimension(const GP_IMAGE*, GP_SIZEF* size);

//Status _stdcall Gp_Image_GetBounds(GP_IMAGE*, GP_RECTF* srcRect, Unit* srcUnit);
Status
Gp_Image_GetBounds(
    const GP_IMAGE* this,
    GP_RECTF *srcRect,
    Unit *srcUnit
    );

UINT _stdcall Gp_Image_GetWidth(const GP_IMAGE*);


UINT _stdcall Gp_Image_GetHeight(const GP_IMAGE*);
REAL _stdcall Gp_Image_GetHorizontalResolution(const GP_IMAGE*);
REAL _stdcall Gp_Image_GetVerticalResolution(const GP_IMAGE*);
UINT _stdcall Gp_Image_GetFlags(const GP_IMAGE*);
Status _stdcall Gp_Image_GetRawFormat(const GP_IMAGE*, GUID *format);
Gp_PixelFormat _stdcall Gp_Image_GetPixelFormat(const GP_IMAGE*);
INT _stdcall Gp_Image_GetPaletteSize(const GP_IMAGE*);
Status _stdcall Gp_Image_GetPalette(const GP_IMAGE*, GP_COLORPALETTE* palette, INT size);
Status _stdcall Gp_Image_SetPalette(GP_IMAGE*, const GP_COLORPALETTE* palette);
GP_IMAGE* _stdcall Gp_Image_GetThumbnailImage(
    const GP_IMAGE*,
    UINT thumbWidth,
    UINT thumbHeight,
    GetThumbnailImageAbort callback, // = NULL
    VOID* callbackData = NULL
);

UINT _stdcall Gp_Image_GetFrameDimensionsCount(const GP_IMAGE*);
Status _stdcall Gp_Image_GetFrameDimensionsList(const GP_IMAGE*, GUID* dimensionIDs, UINT count);
UINT _stdcall Gp_Image_GetFrameCount(const GP_IMAGE*, const GUID* dimensionID);
Status _stdcall Gp_Image_SelectActiveFrame(GP_IMAGE*, const GUID* dimensionID, UINT frameIndex);
Status _stdcall Gp_Image_RotateFlip(GP_IMAGE*, Gp_RotateFlipType rotateFlipType);
UINT _stdcall Gp_Image_GetPropertyCount(GP_IMAGE*);
Status _stdcall Gp_Image_GetPropertyIdList(const GP_IMAGE*, UINT numOfProperty, PROPID* list);
UINT _stdcall Gp_Image_GetPropertyItemSize(const GP_IMAGE*, PROPID propId);
Status _stdcall Gp_Image_GetPropertyItem(const GP_IMAGE*, PROPID propId, UINT propSize, GP_PROPERTYITEM* buffer);
Status _stdcall Gp_Image_GetPropertySize(const GP_IMAGE*, UINT* totalBufferSize, UINT* numProperties);
Status _stdcall Gp_Image_GetAllPropertyItems(
    const GP_IMAGE*,
    UINT totalBufferSize,
    UINT numProperties,
    GP_PROPERTYITEM* allItems
);
Status _stdcall Gp_Image_RemovePropertyItem(GP_IMAGE*, PROPID propId);
Status _stdcall Gp_Image_SetPropertyItem(GP_IMAGE*, const GP_PROPERTYITEM* item);

UINT  _stdcall Gp_Image_GetEncoderParameterListSize(const GP_IMAGE*, const CLSID* clsidEncoder);
Status _stdcall Gp_Image_GetEncoderParameterList(
    const GP_IMAGE*,
    const CLSID* clsidEncoder,
    UINT size,
    GP_ENCODERPARAMETERS* buffer
);

// Support for Middle East localization (right-to-left mirroring)
Gp_ImageLayout _stdcall Gp_Image_GetLayout(const GP_IMAGE*);
Status _stdcall Gp_Image_SetLayout(GP_IMAGE*, const Gp_ImageLayout layout);
Status _stdcall Gp_Image_GetLastStatus(GP_IMAGE*);

/*
protected:

    Image() {}
*/

GP_IMAGE overloaded
Gp_Image(
    GP_GPIMAGE *nativeImage,
    GpStatus status
    );

VOID _stdcall
Gp_Image_SetNativeImage(
    GP_IMAGE*,
    GP_GPIMAGE* nativeImage
    );


GP_IMAGE overloaded
Gp_Image(
    GP_GPIMAGE *nativeImage,
    GpStatus status
    )
{
    GP_IMAGE this;
    this.lastResult = status;
    Gp_Image_SetNativeImage(this,nativeImage);
    return this;
}

VOID _stdcall
Gp_Image_SetNativeImage(
    GP_IMAGE* this,
    GP_GPIMAGE* nativeImage
    )
{
    this.nativeImage = nativeImage;
}

Status _stdcall Gp_Image_SetStatus(GP_IMAGE* this, GpStatus status)
{
    if (status != Gp_Ok)
        return (this.lastResult = status);
    else
        return status;
}

// Disable copy constructor and assignment operator
void overloaded Gp_Image(GP_IMAGE*, const GP_IMAGE*);

// GP_IMAGE* operator=(GP_IMAGE*, const GP_IMAGE* rhs);



/*

#ifdef DCR_USE_NEW_250932

private:

#else

protected:

#endif

};

*/

// ---------------------------------------------------------------------------
/*
class Bitmap : public Image
{
public:
    friend class Image;
    friend class CachedBitmap;
*/

typedef struct tagGp_Bitmap
{
    GP_GPBITMAP* nativeImage;
    //mutable
    GpStatus lastResult;
    //mutable
    GpStatus loadStatus;
}
GP_BITMAP;

GP_BITMAP overloaded Gp_Bitmap(
    const WCHAR *filename,
    BOOL useEmbeddedColorManagement = FALSE
);

GP_BITMAP overloaded Gp_Bitmap(
    IStream *stream,
    BOOL useEmbeddedColorManagement = FALSE
);

//static GP_BITMAP*
GP_BITMAP Gp_Bitmap_FromFile(
    const WCHAR *filename,
    BOOL useEmbeddedColorManagement = FALSE
);

//static GP_BITMAP*
GP_BITMAP Gp_Bitmap_FromStream(
    IStream *stream,
    BOOL useEmbeddedColorManagement = FALSE
);

GP_BITMAP overloaded Gp_Bitmap(
    INT width,
    INT height,
    INT stride,
    Gp_PixelFormat format,
    BYTE* scan0
);

/* redefinition of optional argument 1 in Gp_Bitmap
GP_BITMAP overloaded Gp_Bitmap(
    INT width,
    INT height,
    Gp_PixelFormat format = Gp_PixelFormat32bppARGB
);
*/

GP_BITMAP overloaded Gp_Bitmap(
    INT width,
    INT height,
    GP_GRAPHICS* target
);

GP_BITMAP* overloaded Gp_Bitmap_Clone(
    GP_BITMAP*,
    const GP_RECTI* rect,
    Gp_PixelFormat format
);

GP_BITMAP* overloaded Gp_Bitmap_Clone(
    GP_BITMAP*,
    INT x, INT y,
    INT width, INT height,
    Gp_PixelFormat format
);
GP_BITMAP* overloaded Gp_Bitmap_Clone(
    GP_BITMAP*,
    const GP_RECTF* rect,
    Gp_PixelFormat format
);
GP_BITMAP* overloaded Gp_Bitmap_Clone(
    GP_BITMAP*,
    REAL x, REAL y,
    REAL width, REAL height,
    Gp_PixelFormat format
);
Status _stdcall Gp_Bitmap_LockBits(
    GP_BITMAP*,
    const GP_RECTI* rect,
    UINT flags,
    Gp_PixelFormat format,
    GP_BITMAPDATA* lockedBitmapData
);
Status _stdcall Gp_Bitmap_UnlockBits(GP_BITMAP*, GP_BITMAPDATA* lockedBitmapData);
Status _stdcall Gp_Bitmap_GetPixel(GP_BITMAP*, INT x, INT y, GP_COLOR *color);
Status _stdcall Gp_Bitmap_SetPixel(GP_BITMAP*, INT x, INT y, const GP_COLOR* color);
Status _stdcall Gp_Bitmap_SetResolution(GP_BITMAP*, REAL xdpi, REAL ydpi);

// GDI interop:

GP_BITMAP overloaded Gp_Bitmap(IDirectDrawSurface7* surface);
GP_BITMAP overloaded Gp_Bitmap(const BITMAPINFO* gdiBitmapInfo, VOID* gdiBitmapData);
GP_BITMAP overloaded Gp_Bitmap(HBITMAP hbm, HPALETTE hpal);
GP_BITMAP overloaded Gp_Bitmap(HICON hicon);
GP_BITMAP overloaded Gp_Bitmap(HINSTANCE hInstance, const WCHAR * bitmapName);
//static
//GP_BITMAP*
GP_BITMAP _stdcall Gp_Bitmap_FromDirectDrawSurface7(IDirectDrawSurface7* surface);
//static
//GP_BITMAP*
GP_BITMAP _stdcall Gp_Bitmap_FromBITMAPINFO(const BITMAPINFO* gdiBitmapInfo, VOID* gdiBitmapData);
//static
//GP_BITMAP*
GP_BITMAP _stdcall Gp_Bitmap_FromHBITMAP(HBITMAP hbm, HPALETTE hpal);
//static
//GP_BITMAP*
GP_BITMAP _stdcall Gp_Bitmap_FromHICON(HICON hicon);
//static
//GP_BITMAP*
GP_BITMAP _stdcall Gp_Bitmap_FromResource(HINSTANCE hInstance, const WCHAR * bitmapName);
Status _stdcall Gp_Bitmap_GetHBITMAP(const GP_BITMAP*, const GP_COLOR* colorBackground, HBITMAP *hbmReturn);
Status _stdcall Gp_Bitmap_GetHICON(const GP_BITMAP*, HICON *hicon);

GP_BITMAP overloaded Gp_Bitmap(const GP_BITMAP*);

// GP_BITMAP* operator=(const GP_BITMAP*, const GP_BITMAP* rhs);

GP_BITMAP overloaded Gp_Bitmap(GP_GPBITMAP *nativeBitmap);

#ifdef DCR_USE_NEW_250932
private:
protected:
#endif



// ---------------------------------------------------------------------------

// class CustomLineCap : public GplusBase { public: friend class Pen;

// protected:
typedef struct tagGp_CustomLineCap
{
    GP_GPCUSTOMLINECAP* nativeCap;
    //mutable
    GpStatus lastResult;
}
GP_CUSTOMLINECAP;


GP_CUSTOMLINECAP overloaded Gp_CustomLineCap(
    const GP_GRAPHICSPATH* fillPath,
    const GP_GRAPHICSPATH* strokePath,
    LineCap baseCap /* = LineCapFlat */,
    REAL baseInset = 0.0
);
//    virtual ~CustomLineCap();
void _stdcall Gp_CustomLineCap_Dtor(GP_CUSTOMLINECAP*);

// GP_CUSTOMLINECAP* _stdcall Gp_CustomLineCap_Clone(const GP_CUSTOMLINECAP*);
GP_CUSTOMLINECAP _stdcall Gp_CustomLineCap_Clone(const GP_CUSTOMLINECAP*);

Status _stdcall Gp_CustomLineCap_SetStrokeCaps(
    GP_CUSTOMLINECAP*,
    LineCap startCap,
    LineCap endCap
);

Status _stdcall Gp_CustomLineCap_GetStrokeCaps(
    const GP_CUSTOMLINECAP*,
    LineCap* startCap,
    LineCap* endCap
);
/*
Status _stdcall Gp_CustomLineCap_SetStrokeCap( const GP_CUSTOMLINECAP * this,
    				LineCap strokeCap);
{
    // This changes both start and and caps.
//    return Gp_CustomLineCap_SetStrokeCaps(this, strokeCap, strokeCap);
}
*/

Status _stdcall Gp_CustomLineCap_SetStrokeJoin( GP_CUSTOMLINECAP*, LineJoin lineJoin);
LineJoin _stdcall Gp_CustomLineCap_GetStrokeJoin(const GP_CUSTOMLINECAP*);
Status _stdcall Gp_CustomLineCap_SetBaseCap(GP_CUSTOMLINECAP*, LineCap baseCap);
LineCap _stdcall Gp_CustomLineCap_GetBaseCap(const GP_CUSTOMLINECAP*);
Status _stdcall Gp_CustomLineCap_SetBaseInset(GP_CUSTOMLINECAP*, REAL inset);
REAL _stdcall Gp_CustomLineCap_GetBaseInset(const GP_CUSTOMLINECAP*);
Status _stdcall Gp_CustomLineCap_SetWidthScale(GP_CUSTOMLINECAP*, REAL widthScale);
REAL _stdcall Gp_CustomLineCap_GetWidthScale(const GP_CUSTOMLINECAP*);

// protected:
GP_CUSTOMLINECAP overloaded Gp_CustomLineCap(void);

GP_CUSTOMLINECAP overloaded Gp_CustomLineCap(const GP_CUSTOMLINECAP*);

Status _stdcall Gp_CustomLineCap_SetStatus( GP_CUSTOMLINECAP* this, GpStatus status)
{
    if (status != Gp_Ok)
        return (this.lastResult = status);
    else
        return status;
}


GP_CUSTOMLINECAP overloaded Gp_CustomLineCap(const GP_CUSTOMLINECAP* customLineCap)
{
    GP_CUSTOMLINECAP this = customLineCap;
    Gp_CustomLineCap_SetStatus(this,Gp_NotImplemented);
    return this;
}

VOID _stdcall Gp_CustomLineCap_SetNativeCap( GP_CUSTOMLINECAP* this,
			    GP_GPCUSTOMLINECAP* nativeCap)
{
    this.nativeCap = nativeCap;
}


GP_CUSTOMLINECAP overloaded Gp_CustomLineCap( GP_GPCUSTOMLINECAP* nativeCap,
						    GpStatus status)
{
    GP_CUSTOMLINECAP this;
    this.lastResult = status;
    Gp_CustomLineCap_SetNativeCap(this,nativeCap);
    return this;
}

// ---------------------------------------------------------------------------

// class CachedBitmap : public GplusBase {   friend Graphics; public:


GP_CACHEDBITMAP overloaded Gp_CachedBitmap(GP_BITMAP *bitmap, GP_GRAPHICS *graphics);

void _stdcall Gp_CachedBitmap_Dtor(GP_CACHEDBITMAP*);

Status _stdcall Gp_CachedBitmap_GetLastStatus(GP_CACHEDBITMAP*); //const

GP_CACHEDBITMAP overloaded Gp_CachedBitmap(const GP_CACHEDBITMAP*);

#endif  // !_GDIPLUSHEADERS.HPP
