/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiplusPen.h
*
* Abstract:
*
*   Pen related declarations
*
\**************************************************************************/
#ifndef _GDIPLUSPEN_H
#define _GDIPLUSPEN_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_CustomLineCap
{
    GP_GPCUSTOMLINECAP * nativeCap;
    GpStatus lastResult;
}GP_CUSTOMLINECAP;

typedef struct tagGp_Pen
{
    GP_GPPEN * nativePen; // GdipPen
    GpStatus lastResult;
}GP_PEN;

//----------------------------------------------------------------------------
// Pen DLL methods API calls
//----------------------------------------------------------------------------

GpStatus _stdcall GdipCreatePen1(ARGB color, REAL width, GpUnit unit, GP_GPPEN **pen);
GpStatus _stdcall GdipCreatePen2(GP_GPBRUSH * brush, REAL width, GpUnit unit, GP_GPPEN ** pen);
GpStatus _stdcall GdipCreatePen2(GP_GPBRUSH * brush, REAL width, GpUnit unit, GP_GPPEN ** pen);
GpStatus _stdcall GdipClonePen(GP_GPPEN *pen, GP_GPPEN **clonepen);
GpStatus _stdcall GdipDeletePen(GP_GPPEN *pen);
GpStatus _stdcall GdipSetPenWidth(GP_GPPEN *pen, REAL width);
GpStatus _stdcall GdipGetPenWidth(GP_GPPEN *pen, REAL *width);
GpStatus _stdcall GdipSetPenUnit(GP_GPPEN *pen, GpUnit unit);
GpStatus _stdcall GdipGetPenUnit(GP_GPPEN *pen, GpUnit *unit);
GpStatus _stdcall GdipSetPenStartCap(GP_GPPEN *pen, GpLineCap startCap);
GpStatus _stdcall GdipSetPenEndCap(GP_GPPEN *pen, GpLineCap endCap);
GpStatus _stdcall GdipGetPenStartCap(GP_GPPEN *pen, GpLineCap *startCap);
GpStatus _stdcall GdipGetPenEndCap(GP_GPPEN *pen, GpLineCap *endCap);
GpStatus _stdcall GdipSetPenLineJoin(GP_GPPEN *pen, GpLineJoin lineJoin);
GpStatus _stdcall GdipGetPenLineJoin(GP_GPPEN *pen, GpLineJoin *lineJoin);
GpStatus _stdcall GdipSetPenCustomStartCap(GP_GPPEN *pen,GP_GPCUSTOMLINECAP* customCap);
GpStatus _stdcall GdipGetPenCustomStartCap(GP_GPPEN *pen,GP_GPCUSTOMLINECAP** customCap);
GpStatus _stdcall GdipSetPenCustomEndCap(GP_GPPEN *pen,	GP_GPCUSTOMLINECAP* customCap);
GpStatus _stdcall GdipGetPenCustomEndCap(GP_GPPEN *pen,GP_GPCUSTOMLINECAP** customCap);
GpStatus _stdcall GdipSetPenMiterLimit(GP_GPPEN *pen, REAL miterLimit);
GpStatus _stdcall GdipGetPenMiterLimit(GP_GPPEN *pen, REAL *miterLimit);
GpStatus _stdcall GdipSetPenMode(GP_GPPEN *pen, GpPenAlignment penMode);
GpStatus _stdcall GdipGetPenMode(GP_GPPEN *pen, GpPenAlignment *penMode);
GpStatus _stdcall GdipSetPenTransform(GP_GPPEN *pen, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipGetPenTransform(GP_GPPEN *pen, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipResetPenTransform(GP_GPPEN *pen);
GpStatus _stdcall GdipMultiplyPenTransform(GP_GPPEN *pen,const GP_GPMATRIX *matrix, GpMatrixOrder order);
GpStatus _stdcall GdipMultiplyPenTransform(GP_GPPEN *pen,const GP_GPMATRIX *matrix, GpMatrixOrder order);
GpStatus _stdcall GdipTranslatePenTransform(GP_GPPEN *pen, REAL dx,	REAL dy, GpMatrixOrder order);
GpStatus _stdcall GdipScalePenTransform(GP_GPPEN *pen, REAL sx, REAL sy, GpMatrixOrder order);
GpStatus _stdcall GdipRotatePenTransform(GP_GPPEN *pen,	REAL angle, GpMatrixOrder order);
GpStatus _stdcall GdipSetPenColor(GP_GPPEN *pen, ARGB argb);
GpStatus _stdcall GdipGetPenColor(GP_GPPEN *pen, ARGB *argb);
GpStatus _stdcall GdipSetPenBrushFill(GP_GPPEN *pen, GP_GPBRUSH *brush);
GpStatus _stdcall GdipGetPenBrushFill(GP_GPPEN *pen, GP_GPBRUSH **brush);
GpStatus _stdcall GdipGetPenFillType(GP_GPPEN *pen, GpPenType* type);
GpStatus _stdcall GdipGetPenDashStyle(GP_GPPEN *pen, GpDashStyle *dashstyle);
GpStatus _stdcall GdipSetPenDashStyle(GP_GPPEN *pen, GpDashStyle dashstyle);
GpStatus _stdcall GdipGetPenDashOffset(GP_GPPEN *pen, REAL *offset);
GpStatus _stdcall GdipSetPenDashOffset(GP_GPPEN *pen, REAL offset);
GpStatus _stdcall GdipGetPenDashCount(GP_GPPEN *pen, INT *count);
GpStatus _stdcall GdipSetPenDashArray(GP_GPPEN *pen,const REAL *dash, INT count);
GpStatus _stdcall GdipGetPenDashArray(GP_GPPEN *pen, REAL *dash, INT count);
GpStatus _stdcall GdipGetPenCompoundCount(GP_GPPEN *pen, INT *count);
GpStatus _stdcall GdipSetPenCompoundArray(GP_GPPEN *pen,const REAL *dash, INT count);
GpStatus _stdcall GdipGetPenCompoundArray(GP_GPPEN *pen,REAL *dash, INT count);


//----------------------------------------------------------
// GdiPlusLib.lib functions
//----------------------------------------------------------
VOID 	GpPen_Delete(GP_PEN * this);
VOID 	GpPen_SetNative(GP_PEN * this, GP_GPPEN * nativePen);
GP_PEN 	GpPen_Color(COLOR * color, REAL width);
GP_PEN 	GpPen_Brush(GP_BRUSH * brush, REAL width);
GP_PEN 	GpPen_Clone(GP_PEN * this);
GpStatus GpPen_SetWidth(GP_PEN * this, REAL width);
REAL 	GpPen_GetWidth(GP_PEN * this);
GpStatus GpPen_SetStartCap(GP_PEN * this,GpLineCap startCap);
GpStatus GpPen_SetEndCap(GP_PEN * this,GpLineCap endCap);
GpLineCap GpPen_GetStartCap(GP_PEN * this);
GpLineCap GpPen_GetEndCap(GP_PEN * this);
GpStatus GpPen_SetLineJoin(GP_PEN * this, GpLineJoin lineJoin);
GpLineJoin GpPen_GetLineJoin(GP_PEN * this);
GpStatus GpPen_SetCustomStartCap(GP_PEN * this, GP_CUSTOMLINECAP * customCap);
GpStatus GpPen_GetCustomStartCap(GP_PEN * this, GP_CUSTOMLINECAP* customCap);
GpStatus GpPen_SetCustomEndCap(GP_PEN * this, const GP_CUSTOMLINECAP* customCap);
GpStatus GpPen_GetCustomEndCap(GP_PEN * this, GP_CUSTOMLINECAP* customCap);
GpStatus GpPen_SetMiterLimit(GP_PEN * this, REAL miterLimit);
REAL 	GpPen_GetMiterLimit(GP_PEN * this);
GpStatus GpPen_SetAlignment(GP_PEN * this, GpPenAlignment penAlignment);
GpPenAlignment GpPen_GetAlignment(GP_PEN * this);
GpStatus GpPen_SetTransform(GP_PEN * this, GP_MATRIX * matrix);
GpStatus GpPen_GetTransform(GP_PEN * this, GP_MATRIX* matrix);
GpStatus GpPen_ResetTransform(GP_PEN * this);
GpStatus GpPen_MultiplyTransform(GP_PEN * this, const GP_MATRIX* matrix, GpMatrixOrder order);
GpStatus GpPen_TranslateTransform(GP_PEN * this, REAL dx, REAL dy, GpMatrixOrder order);
GpStatus GpPen_ScaleTransform(GP_PEN * this, REAL sx, REAL sy, GpMatrixOrder order);
GpStatus GpPen_RotateTransform(GP_PEN * this,REAL angle, GpMatrixOrder order);
GpPenType GpPen_GetPenType(GP_PEN * this);
GpStatus GpPen_SetColor(GP_PEN * this, const COLOR * color);
GpStatus GpPen_SetBrush(GP_PEN * this, const GP_BRUSH* brush);
GpStatus GpPen_GetColor( GP_PEN * this, COLOR * color);
GP_BRUSH * GpPen_GetBrush(GP_PEN * this);
GpDashStyle GpPen_GetDashStyle(GP_PEN * this);
GpStatus GpPen_SetDashStyle(GP_PEN * this, GpDashStyle dashStyle);
REAL 	GpPen_GetDashOffset(GP_PEN * this);
GpStatus GpPen_SetDashOffset(GP_PEN * this, REAL dashOffset);
GpStatus GpPen_SetDashPattern(GP_PEN * this, const REAL* dashArray, INT count);
INT 	GpPen_GetDashPatternCount(GP_PEN * this);
GpStatus GpPen_GetDashPattern(GP_PEN * this, REAL * dashArray, INT count);
GpStatus GpPen_SetCompoundArray(GP_PEN * this, const REAL* compoundArray, INT count);
INT 	GpPen_GetCompoundArrayCount(GP_PEN * this);
GpStatus GpPen_GetCompoundArray(GP_PEN * this, REAL* compoundArray, INT count);
GpStatus GpPen_GetLastStatus(GP_PEN * this);

#endif
